<template>
  <b-container>
    <div class="background_bloc" />
    <h1 class="title">
      {{ categorie }}
    </h1>
  </b-container>
  <b-container>
    <b-row v-if="produits.length">
      <b-col 
        v-for="(produit, index) in produits"
        :key="produit"
        sm="12"
        md="4"
      >
        <NomVendeur :id="produit.vendeur.id" />
        <CardProduit
          :id="produit.id"
          :id-vendeur="produit.vendeur.id"
          :titre="produit.titre"
          :prix="produit.prix"
          :image="images[index]"
        />
      </b-col>
      <button
        v-if="currentPage < nbTotalPages"
        class="btn-cta load-more"
        :data-page="currentPage"
        @click="loadMore()"
      >
        Charger plus
      </button>
    </b-row>        
    <p v-else>
      Il n'y a pas de produit pour le moment
    </p>
  </b-container>
</template>

<script>
import { useStore } from '@/store/store';
import axios from 'axios';
import CardProduit from '@/components/CardProduit.vue'
import NomVendeur from '@/components/NomVendeur.vue'



export default {

    components: {
      NomVendeur,
      CardProduit
    },
    
    data() {;
        const store = useStore();
        const url = process.env.VUE_APP_URL;


        return {
            url,
            store,
            produits: [],
            categorie: '',
            images: [],
            nbTotalPages: '',
            currentPage: '1'
        }
    },

    mounted() {
        axios.get(this.url + "/api/produits?order[id]=desc")
        .then(res => {
                let arr = res.data['hydra:member'];
                if(res.data['hydra:totalItems'] > 15){
                    this.nbTotalPages = Math.ceil(res.data['hydra:totalItems'] / 15);
                }
                for (let i = 0; i < arr.length; i++) {
                    const produit = arr[i];
                    if(produit.mediaObjects[0] == undefined){
                        this.images.push('noimg');
                    } else {
                        this.images.push(produit.mediaObjects[0].contentUrl);
                    }
                    this.produits.push(produit);
                }
            })
    },

    methods: {
        loadMore(){
            this.currentPage = parseInt(this.currentPage) + 1;
            axios.get(this.url + "/api/produits?order[id]=desc&page=" + this.currentPage)
            .then(res => {
                let arr = res.data['hydra:member'];
                for (let i = 0; i < arr.length; i++) {
                    const produit = arr[i];
                    if(produit.mediaObjects[0] == undefined){
                        this.images.push('noimg');
                    } else {
                        this.images.push(produit.mediaObjects[0].contentUrl);
                    }
                    this.produits.push(produit);
                }
            })
        }
    }
}
</script>
